﻿* Encoding: UTF-8.
*Horizontal tools
*SPSS macros by Kirill Orlov
*kior@akado.ru, ttnphns@gmail.com
*https://www.spsstools.net/en/KO-spssmacros
*All rights reserved.

*/*!KO_HRESC*/vers2***************************************************************************************.
define !KO_hresc(vars= !charend('/') /cap= !charend('/') /trans= !charend('/') /discret= !charend('/') /nvalid= !charend('/')
                /missing= !charend('/') /flag= !charend('/'))
exec.
!let !ok= 1 !let !format= 'f8.4'
!if (!cap<>!null !and !missing='INCLUDE') !then !let !ok= 0
-echo ' '.
-echo '>ERROR. MISSING=INCLUDE is not allowed with CAP specified.'.
!else !if (!trans=!null) !then !let !ok= 0
-echo ' '.
-echo '>ERROR. TRANS is not specified.'.
!else !if (!cap=!null !and !flag='YES') !then !let !ok= 0
-echo ' '.
-echo '>ERROR. FLAG=YES is allowed only with CAP specified.'.
!else !if (!discret<>!null) !then !let !discr= !head(!discret) !let !dec= !head(!tail(!discret))
 !if (!dec=!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. In optional DISCRET, keyword and integer digit should be specified.'.
 !else !if (!dec<>0 !and !dec<>1 !and !dec<>2 !and !dec<>3) !then !let !ok= 0
- echo ''.
- echo '>ERROR. Parameter d in DISCRET can be only 0, 1, 2, or 3.'.
 !else
  !if (!dec=0) !then !let !mult= 1 !let !format= 'f8' !ifend
  !if (!dec=1) !then !let !mult= 0.1 !let !format= 'f8.1' !ifend
  !if (!dec=2) !then !let !mult= 0.01 !let !format= 'f8.2' !ifend
  !if (!dec=3) !then !let !mult= 0.001 !let !format= 'f8.3' !ifend
 !ifend !ifend
!ifend !ifend !ifend !ifend
!if (!ok) !then
 !let !cp= !unquote(!cap) !let !newlist= !conc(!cp,1,' to ',!cp)
 !if (!cap=!null) !then !let !newv= 'v'
  !if (!trans='SMED1' !or !trans='SMED2' !or !trans='SS' !or !trans='ZABS') !then !let !newlist= '#1 to #' !ifend
 !else !let !newv= 'newv'
 !ifend
 !if (!nvalid<>!null) !then !let !n= !conc('.',!nvalid) !ifend
 !let !vars1= !null !let !vars2= !null !let !vars3= !null !let !wasto= 0
 !do !w !in (!vars)
  !if (!upcase(!w)='TO') !then !let !wasto= 1
  !else
   !if (!wasto) !then !let !w2= !conc(' to ',!w)
    !let !vars1= !conc(!vars1,'/',!quote(!w2)) !let !vars2= !conc(!vars2,!w2) !let !vars3= !conc(!vars3,'/',!quote(!w2))
   !else
    !let !vars1= !conc(!vars1,'/',!quote(!conc(' ',!w))) !let !vars2= !conc(!vars2,',',!w) !let !vars3= !conc(!vars3,'/',!quote(!conc(' ,',!w)))
   !ifend
   !let !wasto= 0
  !ifend
 !doend
 !let !vars2= !tail(!vars2) !let !vars3= !conc(!quote(!head(!vars)),!tail(!tail(!vars3)))
-count nvars###= !vars (lo thru hi miss).
-string nvars##$ (a8).
-comp nvars##$= ltrim(string(nvars###,f8)).
-do if $casenum=1.
  !if (!cap<>!null) !then
-  write outfile= 'temp_KO_hresc_0.sps'
      /'numeric ' !quote(!newlist) nvars##$ ' (' !quote(!format) ').'
      /'var lev ' !quote(!newlist) nvars##$ ' (sca).'.
  !ifend
- write outfile= 'temp_KO_hresc_1.sps'
      /'do rep v= ' !vars1
      /' /newv= ' !quote(!newlist) nvars##$ '.'.
  !if (!trans='SMED1' !or !trans='ZABS') !then !let !func= 'mean' !else !if (!trans='SMED2') !then !let !func= 'median'
  !else !let !func= 'sum'
  !ifend !ifend
- write outfile= 'temp_KO_hresc_2.sps'
    !if (!cap<>!null !or !trans='SMED1' !or !trans='SMED2' !or !trans='SS' !or !trans='ZABS') !then
     !if (!trans='CLR') !then
      /'comp #nvalid= nvalid(' !quote(!newlist) nvars##$ ').'
     !else
      /'comp #sum= ' !quote(!conc(!func,!n,'(',!newlist)) nvars##$ ').'
     !ifend
    !else
     !if (!trans='CLR') !then
      /'comp #nvalid= nvalid(' !vars3 ').'
     !else
      /'comp #sum= ' !quote(!conc(!func,!n,'(')) !vars3 ').'
     !ifend
    !ifend .
-end if.
 !if (!cap=!null !and !missing<>'INCLUDE') !then
- recode !vars (miss=sysmis).
 !ifend
-exec.
 !if (!cap=!null) !then
-  miss val !vars ().
 !else
- insert file= 'temp_KO_hresc_0.sps'.
 !ifend
 !if (!trans='Z') !then
- comp #mean= !conc(mean,!n)(!vars2).
- comp #sd= !conc(sd,!n)(!vars2).
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= (v-#mean)/(#sd+(#sd=0)).
-  if sysmis(#sd) !newv= $sysmis.
 !else !if (!trans='C') !then
- comp #mean= !conc(mean,!n)(!vars2).
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= v-#mean.
 !else !if (!trans='SS') !then
- insert file= 'temp_KO_hresc_1.sps'.
-  comp newv= v*v.
- end rep.
- insert file= 'temp_KO_hresc_2.sps'.
- comp #sum= sqrt(#sum).
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= v/(#sum+(#sum=0)).
-  if sysmis(#sum) !newv= $sysmis.
 !else !if (!trans='SUM') !then
- comp #sum= !conc(sum,!n)(!vars2).
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= v/(#sum+(#sum=0)).
-  if sysmis(#sum) !newv= $sysmis.
 !else !if (!trans='RANGE') !then
- comp #range= !conc(max,!n)(!vars2)-!conc(min,!n)(!vars2).
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= v/(#range+(#range=0)).
-  if sysmis(#range) !newv= $sysmis.
 !else !if (!trans='RESCALE') !then
- comp #min= !conc(min,!n)(!vars2).
- comp #range= !conc(max,!n)(!vars2)-#min.
- insert file= 'temp_KO_hresc_1.sps'.
-  do if #range=0.
-   do if miss(v).
-    comp !newv= $sysmis.
-   else.
-    comp !newv= .5.
-   end if.
-  else.
-   comp !newv= (v-#min)/#range.
-  end if.
-  if sysmis(#range) !newv= $sysmis.
 !else !if (!trans='EXP') !then
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= exp(v).
- end rep.
- insert file= 'temp_KO_hresc_2.sps'.
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= !newv/(#sum+(#sum=0)).
-  if sysmis(#sum) !newv= $sysmis.
 !else !if (!trans='CLR') !then
- comp #sum= !conc(sum,!n)(!vars2).
- comp #gmean= 1.
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= v/#sum.
-  if not miss(!newv) #gmean= #gmean*!newv.
- end rep.
- insert file= 'temp_KO_hresc_2.sps'.
- comp #gmean= #gmean**(1/(#nvalid+(#nvalid=0))).
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= ln(!newv/#gmean).
 !else !if (!trans='DMED') !then
- comp #med= !conc(median,!n)(!vars2).
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= v-#med.
 !else !if (!trans='SMED1' !or !trans='SMED2') !then
- comp #med= !conc(median,!n)(!vars2).
- insert file= 'temp_KO_hresc_1.sps'.
-  comp newv= abs(v-#med).
- end rep.
- insert file= 'temp_KO_hresc_2.sps'.
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= (v-#med)/(#sum+(#sum=0)).
-  if sysmis(#sum) !newv= $sysmis.
 !else !if (!trans='ZABS') !then
- comp #mean= !conc(mean,!n)(!vars2).
- insert file= 'temp_KO_hresc_1.sps'.
-  comp newv= abs(v-#mean).
- end rep.
- insert file= 'temp_KO_hresc_2.sps'.
- insert file= 'temp_KO_hresc_1.sps'.
-  comp !newv= (v-#mean)/(#sum+(#sum=0)).
-  if sysmis(#sum) !newv= $sysmis.
 !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend !ifend
 !if (!discret<>!null) !then
- comp !newv= !discr(!newv,!mult).
 !ifend
-end rep.
 !if (!flag='YES') !then
- comp consta#$= $sysmis.
- comp nvalid#$= nvalid(!vars2).
- comp #@min= min(!vars2).
- comp #@max= max(!vars2).
- do if #@min=0 and #@max=0.
-  comp consta#$= 0.
- else if #@min=#@max.
-  comp consta#$= 1.
- end if.
- var lab consta#$ 'Flag constant case in Input variables' nvalid#$ 'No. of valid values in Input variables'.
- val lab consta#$ 0 'Case is constant=0' 1 'Case is constant<>0'.
- var lev consta#$ (nom) nvalid#$ (sca).
- format consta#$ (f1) nvalid#$ (f8).
- echo ''.
- echo '>NOTE. Variables consta#$ and nvalid#$ have been created or updated.'.
 !ifend
-exec.
-del vari nvars### nvars##$.
 !if (!cap=!null) !then
- format !vars (!format).
- var lev !vars (sca).
 !else
- erase file 'temp_KO_hresc_0.sps'.
 !ifend
-erase file 'temp_KO_hresc_1.sps'.
-erase file 'temp_KO_hresc_2.sps'. 
!else
-echo '>!KO_HRESC is not executed.'.
!ifend
!enddefine.

*/*!KO_HRANK*/vers2***************************************************************************************.
define !KO_hrank(vars= !charend('/') /cap= !charend('/') /ties= !charend('/') /order= !charend('/') /trans= !charend('/') /fraction= !charend('/')
             /missing= !charend('/') /nvalid= !charend('/') /flag= !charend('/'))
exec.
!if (!upcase(!head(!tail(!vars)))<>'TO') !then
-echo ' '.
-echo '>ERROR. VARS list must be via "to" (consecutive variables).'.
-echo '>!KO_HRANK is not executed.'.
!else !if (!trans=!null) !then
-echo ' '.
-echo '>ERROR. TRANS is not specified.'.
-echo '>!KO_HRANK is not executed.'.
!else !if (!cap=!null !and !flag='YES') !then
-echo ' '.
-echo '>ERROR. FLAG=YES is allowed only with CAP specified.'.
-echo '>!KO_HRANK is not executed.'.
!else !if (!trans='NTILES' !or !tail(!trans)=' 1') !then
-echo ' '.
-echo '>ERROR. After TRANS=NTILES there must go integer greater than 1.'.
-echo '>!KO_HRANK is not executed.'.
!else !if (!ties='GRADE' !and !trans<>'RANK') !then
-echo ' '.
-echo '>ERROR. TIES=GRADE requires TRANS=RANK.'.
-echo '>!KO_HRANK is not executed.'.
!else
 !if (!cap=!null) !then !let !cp= 'r' !else !let !cp= !unquote(!cap) !ifend
 !if (!order='D') !then !let !ord='max' !else !let !ord= 'min' !ifend
 !if (!missing<>'INCLUDE') !then !let !rcmiss= ' (miss=sysmis) ' !ifend
 !if (!ties='MEAN' !or !ties=!null) !then !let !add= '#t/2+.5'
 !else
  !if (!ties='HIGH') !then !let !add= '#t' !else !let !add= 1 !ifend
 !ifend
 !if (!head(!trans)='NTILES') !then !let !lev= 'ord' !else !let !lev= 'sca' !ifend
 !if (!trans='RANK' !and (!ties='MEAN' !or !ties=!null)) !then !let !form= 'f8.2'
 !else !if (!trans='NORMAL') !then !let !form= 'f8.4'
 !else !let !form= 'f8'
 !ifend !ifend
-count nvars###= !vars (lo thru hi miss).
-string nvars##$ (a8).
-comp nvars##$= ltrim(string(nvars###,f8)).
-do if $casenum=1.
- write outfile= 'temp_KO_hrank_1.sps'
     /!quote(!conc('recode ',!vars,!rcmiss,' (else=copy) into #1 to #')) nvars##$ '.'
     /'comp #n= nvalid(#1 to #' nvars##$ ').'
     /'vector #= #1 to #' nvars##$
     /!quote(!conc(' /',!cp)) !if (!cap=!null) !then '=' !quote(!vars) !else '(' nvars##$ !quote(!conc(!form,')')) !ifend '.'
    !if (!cap<>!null) !then
     /!quote(!conc('var lev ',!cp,1,' to ',!cp)) nvars##$ !quote(!conc('(',!lev,').'))
    !ifend .
- write outfile= 'temp_KO_hrank_2.sps'
     /'loop #j= 1 to ' nvars##$ 'if nvalid(#1 to #' nvars##$ ')>0.'
     /'comp #m= ' !quote(!conc(!ord,'(#1 to #')) nvars##$ ').'.
- write outfile= 'temp_KO_hrank_3.sps'
     /'recode ' !if (!cap=!null) !then !quote(!vars) !else !quote(!conc(!cp,1,' to ',!cp)) nvars##$ !ifend '(else=sysmis).'.
-end if.
-exec.
 !if (!cap=!null !and !missing<>'INCLUDE') !then
- recode !vars (miss=sysmis).
 !ifend
-insert file= 'temp_KO_hrank_1.sps'.
-comp #rnk= 0.
-comp #b= 0.
-insert file= 'temp_KO_hrank_2.sps'.
  !if (!ties<>'GRADE') !then
-  comp #t= 0.
-  loop #i= 1 to nvars###.
-   if #(#i)=#m #t= #t+1.
-  end loop.
-  comp #rnk= #b+!add.
   !if (!ties='CONDENSE') !then
-   comp #b= #rnk.
   !else
-   comp #b= #b+#t.
   !ifend
  !else !let !rnk= 'comp #rnk= #rnk+1'
  !ifend
  !if (!trans='NORMAL') !then
   !if (!fraction='VW') !then !let !x2= '+1'
   !else !if (!fraction='RANKIT') !then !let !x1= '-.5'
   !else !if (!fraction='TUKEY') !then !let !x1= '-1/3' !let !x2= '+1/3'
   !else !let !x1= '-3/8' !let !x2= '+1/4'
   !ifend !ifend !ifend
-  comp #rnk= probit((#rnk !x1)/(#n !x2)).
  !else !if (!head(!trans)='NTILES') !then
-  comp #rnk= trunc(#rnk*!tail(!trans)/(#n+1))+1.
  !ifend !ifend
- loop #i= 1 to nvars###.
-  do if #(#i)=#m.
-   !rnk.
-   comp !cp(#i)= #rnk.
-   comp #(#i)= $sysmis.
-  end if.
- end loop.
-end loop.
-set errors none.
-do if #n< !if (!nvalid=!null) !then 1 !else !nvalid !ifend .
- insert file= 'temp_KO_hrank_3.sps'.
-end if.
-set errors list.
 !if (!flag='YES') !then
- comp nvalid#$= #n.
- var lab nvalid#$ 'No. of valid values in Input variables'.
- var lev nvalid#$ (sca).
- format nvalid#$ (f8).
- echo ''.
- echo '>NOTE. Variable nvalid#$ has been created or updated.'.
 !ifend
-exec.
-del vari nvars### nvars##$.
 !if (!cap=!null) !then
- miss val !vars ().
- format !vars (!form).
- var lev !vars (!lev).
 !ifend
-erase file 'temp_KO_hrank_1.sps'.
-erase file 'temp_KO_hrank_2.sps'.
-erase file 'temp_KO_hrank_3.sps'.
!ifend !ifend !ifend !ifend !ifend
!enddefine.

*/*!KO_HSORT*/vers2***************************************************************************************.
define !KO_hsort(vars= !charend('/') /cap= !charend('/') /cases= !charend('/') /selvar= !charend('/') /order= !charend('/') /missing= !charend('/')
             /misspos= !charend('/') /redupl= !charend('/'))
exec.
!if (!upcase(!head(!tail(!vars)))<>'TO') !then
-echo ' '.
-echo '>ERROR. VARS list must be via "to" (consecutive variables).'.
-echo '>!KO_HSORT is not executed.'.
!else !if (!head(!selvar)<>!null !and !tail(!selvar)=!null) !then
-echo ' '.
-echo '>ERROR. If SELVAR is specified, it must consist of a varname followed by a condition.'.
-echo '>!KO_HSORT is not executed.'.
!else
 !if (!order='R' !and (!misspos='ORIG' !or !redupl='CROP')) !then
- echo ' '.
- echo '>WARNING. Specification MISSPOS=ORIG or REDUPL=CROP is ignored with ORDER=R.'.
 !ifend
 !let !cp= !unquote(!cap)
 !if (!order='D') !then !let !ord='max' !else !let !ord= 'min' !ifend
 !if (!order='R') !then !let !rn= 'rn' !ifend
 !if (!cap=!null) !then !let !v= 's' !else !let !v= 'v' !ifend
 !if (!missing='INCLUDE') !then !let !mfunc= 'sysmis' !else !let !mfunc= 'missing' !let !rcmiss= ' (miss=sysmis) ' !ifend
 !if (!misspos='ORIG' !and !order<>'R') !then !let !doifp= !conc('do if not ',!mfunc,'(',!v,')') !let !endifp= 'end if' !ifend
 !if (!selvar<>!null) !then !let !selvar2= !head(!selvar) !let !doifs= !conc('do if ',!selvar) !let !endifs= 'end if'
  !if (!cap<>!null) !then !let !elses= 'else' !let !comps= 'comp s= value(v)' !ifend
 !ifend
 !if (!cases='FIRST') !then !let !doiff= 'do if $casenum=1' !let !elsef= 'else' !let !endiff= 'end if' !let !compf1= 'comp p= #i' !let !compf2= 'if p>0 s= #(p)'
  !if (!cap=!null) !then !let !compf3= 'if p=0 s= $sysmis' !ifend
 !ifend
 !if (!redupl<>'CROP' !or !order='R') !then !let !brk= 'break' !ifend
 !if (!cases='FIRST' !and !selvar<>!null) !then
- do if $casenum=1 and (not(!selvar) or missing(!selvar2)).
-  print /' ' /'>ERROR. CASES=FIRST, but the 1st case does not satisfy the SELVAR subcommand condition.'.
- else.
 !ifend
-  count nvars###= !vars (lo thru hi miss).
-  string nvars##$ (a8).
-  comp nvars##$= ltrim(string(nvars###,f8)).
-  do if $casenum=1.
-   write outfile= 'temp_KO_hsort_1.sps'
        !if (!missing<>'INCLUDE' !and !cases='FIRST') !then !let !rcmiss= ''
         /'do if $casenum=1.'
         /'recode ' !quote(!vars) ' (miss=sysmis) (else=copy) into #1 to #' nvars##$ '.'
         /'else.'
        !ifend
         /!quote(!conc('recode ',!vars,!rcmiss,' (else=copy) into #1 to #')) nvars##$ '.'
        !if (!missing<>'INCLUDE' !and !cases='FIRST') !then /'end if.' !ifend
         /'vector #= #1 to #' nvars##$
        !if (!order='R') !then ' /#rn (' nvars##$ ')' !ifend '.'
        !if (!cap<>!null) !then !let !newlist= !quote(!conc(!cp,1,' to ',!cp))
         /'numer ' !newlist nvars##$ '.'
         /'var lev ' !newlist nvars##$ ' (sca).'
        !ifend
        !if (!order='R') !then
         /'do rep #rn= #rn1 to #rn' nvars##$ '.'
         /'comp #rn= uniform(1).' /'end rep.'
        !ifend
         /'do rep s= '
        !if (!cap=!null) !then !quote(!vars) !else !newlist nvars##$ ' /v= ' !quote(!vars) !ifend
        !if (!cases='FIRST') !then ' /p= #p1 to #p' nvars##$ !ifend '.'.
-   write outfile= 'temp_KO_hsort_2.sps'
         /'comp s= ' !quote(!conc(!ord,'(#',!rn,'1 to #',!rn)) nvars##$ ').'
         /'loop #i= 1 to ' nvars##$ '.'.
-  end if.
 !if (!cases='FIRST' !and !selvar<>!null) !then
- end if.
 !ifend
- exec.
- set errors none.
- insert file= 'temp_KO_hsort_1.sps'.
- !doifs.
-  !doiff.
-   !doifp.
-    insert file= 'temp_KO_hsort_2.sps'.
-     set errors list.
-     do if !conc(#,!rn)(#i)=value(s).
       !if (!order='R') !then
-       comp s= #(#i).
-       comp #rn(#i)= $sysmis.
       !ifend
-      comp #(#i)= $sysmis.
-      !compf1.
-      !brk.
-     end if.
-    end loop.
-   !endifp.
-  !elsef.
-   !compf2.
-   !compf3.
-  !endiff.
- !elses.
-  !comps.
- !endifs.
-end rep.
 !if (!cap=!null !and !selvar<>!null) !then
- do if miss(!selvar2).
-  recode !vars (else=sysmis).
- end if.
 !ifend
 !if (!cap=!null !and !missing<>'INCLUDE') !then
- !doifs.
-  !doiff.
-   recode !vars (miss=sysmis).
-  !endiff.
- !endifs.
 !ifend
-exec.
-del vari nvars### nvars##$.
 !if (!cap=!null) !then
  !if (!selvar=!null) !then
-  miss val !vars ().
  !else
-  echo ' '.
-  echo '>NOTE. !KO_HSORT will not abolish possible user-missing definitions in VARS variables,'.
-  echo ' because SELVAR was specified, therefore not all cases might have been affected by the macro.'.
  !ifend
 !ifend
-erase file 'temp_KO_hsort_1.sps'.
-erase file 'temp_KO_hsort_2.sps'. 
!ifend !ifend
!enddefine.

*/*!KO_HQSORT*/vers2***************************************************************************************.
define !KO_hqsort(vars= !charend('/') /cap= !charend('/') /selvar= !charend('/') /order= !charend('/') /redupl= !charend('/'))
exec.
!if (!upcase(!head(!tail(!vars)))<>'TO') !then
-echo ' '.
-echo '>ERROR. VARS list must be via "to" (consecutive variables).'.
-echo '>!KO_HQSORT is not executed.'.
!else !if (!head(!selvar)<>!null !and !tail(!selvar)=!null) !then
-echo ' '.
-echo '>ERROR. If SELVAR is specified, it must consist of a varname followed by a condition.'.
-echo '>!KO_HQSORT is not executed.'.
!else
 !let !cp= !unquote(!cap)
 !if (!order='D') !then !let !ord='<' !else !let !ord= '>' !ifend
 !if (!selvar<>!null) !then !let !selvar2= !head(!selvar) !let !doifs= !conc('do if ',!selvar) !let !endifs= 'end if' !ifend
-count nvars###= !vars (lo thru hi miss).
-string nvars##$ (a8).
-comp nvars##$= ltrim(string(nvars###,f8)).
-do if $casenum=1.
- write outfile= 'temp_KO_hqsort_1.sps'
    !if (!cap<>!null) !then !let !newlist= !quote(!conc(!cp,1,' to ',!cp)) !let !oldlist= !quote(!vars)
      /'numer ' !newlist nvars##$ '.'
      /'var lev ' !newlist nvars##$ ' (sca).'
     !if (!selvar=!null) !then
      /'recode ' !oldlist ' (miss=sysmis) (else=copy) into ' !newlist nvars##$ '.'
     !else
      /'do if miss(' !quote(!selvar2) ').'
      /'recode ' !oldlist ' (else=sysmis) into ' !newlist nvars##$ '.'
      /'else if ' !quote(!selvar) '.'
      /'recode ' !oldlist ' (miss=sysmis) (else=copy) into ' !newlist nvars##$ '.'
      /'else.'
      /'recode ' !oldlist ' (else=copy) into ' !newlist nvars##$ '.'
      /'end if.'
     !ifend
    !ifend
      /'vector v= ' !if (!cap=!null) !then !quote(!vars) !else !newlist nvars##$ !ifend ' /#s #e (' nvars##$ ').'.
- write outfile= 'temp_KO_hqsort_2.sps'
      /'recode #s1 to #s' nvars##$ ' (else=0).'
      /'comp #s(1)= 1.'
      /'comp #e(1)= ' nvars##$ '.'
      /'comp #w= 2.'
      /'loop #r= 1 to ' nvars##$ ' if #s(#r)>0.'
      /'comp #s= #s(#r).'
      /'loop #w= #w to ' nvars##$ ' if #s<#e(#r).'.
-end if.
-exec.
-set errors none.
-insert file= 'temp_KO_hqsort_1.sps'.
-!doifs.
- insert file= 'temp_KO_hqsort_2.sps'.
- set errors list.
-   comp #p= trunc((#s+#e(#r))/2).
-   comp #temp= v(#p).
-   comp v(#p)= v(#s).
-   comp v(#s)= #temp.
-   comp #p= #e(#r).
-   loop #i= #e(#r) to #s+1 by -1.
-    do if v(#i) !ord v(#s) or miss(v(#i)).
-     comp #temp= v(#i).
-     comp v(#i)= v(#p).
-     comp v(#p)= #temp.
-     comp #p= #p-1.
-    end if.
-   end loop.
-   comp #temp= v(#s).
-   comp v(#s)= v(#p).
-   comp v(#p)= #temp.
-   comp #s(#w)= #s.
-   comp #e(#w)= #p-1.
-   comp #s= #p+1.
-  end loop.
- end loop.
 !if (!redupl='CROP') !then
- comp #nvalid= nvalid(!vars).
- comp #w= 1.
- loop #i= 2 to #nvalid.
-  do if v(#i)<>v(#w).
-   comp #w= #w+1.
-   comp v(#w)= v(#i).
-  end if.
- end loop.
- loop #i= #w+1 to #nvalid.
- comp v(#i)= $sysmis.
- end loop.
 !ifend
-!endifs.
 !if (!cap=!null !and !selvar<>!null) !then
- do if miss(!selvar2).
-  recode !vars (else=sysmis).
- end if.
 !ifend
-exec.
-del vari nvars### nvars##$.
 !if (!cap=!null) !then
  !if (!selvar=!null) !then
-  miss val !vars ().
  !else
-  echo ' '.
-  echo '>NOTE. !KO_HQSORT will not abolish possible user-missing definitions in VARS variables,'.
-  echo ' because SELVAR was specified, therefore not all cases might have been affected by the macro.'.
  !ifend
 !ifend
-erase file 'temp_KO_hqsort_1.sps'.
-erase file 'temp_KO_hqsort_2.sps'. 
!ifend !ifend
!enddefine.

*/*!KO_HBINEF*/vers1***************************************************************************************.
define !KO_hbinef(vars= !charend('/') /cap= !charend('/') /k= !charend('/') /order= !charend('/') /incp= !charend('/') /missing= !charend('/')
                 /nvalid= !charend('/') /cutp= !charend('/') /freq= !charend('/') /trunc= !charend('/') /flag= !charend('/'))
exec.
!let !ok= 1
!if (!upcase(!head(!tail(!vars)))<>'TO') !then !let !ok= 0
-echo ''.
-echo '>ERROR. VARS list must be via "to" (consecutive variables).'.
!else !if (!k=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. K is not specified.'.
!else !if (!order=!null !or !tail(!order)<>!null !and !tail(!order)<>' SORTED') !then !let !ok= 0
-echo ''.
-echo '>ERROR. Not specified or incorrectly specified ORDER.'.
!else !if (!incp=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. INCP is not specified.'.
!else !if (!cap=!null !and !flag='YES') !then !let !ok= 0
-echo ''.
-echo '>ERROR. FLAG=YES is allowed only with CAP specified.'.
!else !if (!freq<>!null !and (!unquote(!freq)=!null !or !head(!unquote(!freq))=!null)
       !or !cutp<>!null !and (!unquote(!cutp)=!null !or !head(!unquote(!cutp))=!null)) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Incorrectly specified CUTP or FREQ.'.
!else !if (!trunc<>'NO') !then
 !if (!trunc=!null) !then !let !trd= 4 !else !let !trd= !head(!tail(!trunc)) !ifend
 !if (!trd=1) !then !let !mult= '.001'
 !else !if (!trd=2) !then !let !mult= '.0001'
 !else !if (!trd=3) !then !let !mult= '.00001'
 !else !if (!trd=4 !or (!head(!trunc)='YES' !and !trd=!null)) !then !let !mult= '.000001'
 !else !if (!trd=5) !then !let !mult= '.0000001'
 !else !if (!trd=6) !then !let !mult= '.00000001'
 !else !if (!head(!trunc)='NO') !then !let !ok= 0
- echo ''.
- echo '>ERROR. Incorrectly specified s/c TRUNC.'.
 !else !let !ok= 0
- echo ''.
- echo '>ERROR. Incorrectly specified s/c TRUNC.'.
 !ifend !ifend !ifend !ifend !ifend !ifend !ifend
!ifend !ifend !ifend !ifend !ifend !ifend !ifend
!if (!ok) !then !let !cp= !unquote(!cap) !let !fr= !unquote(!freq) !let !ctp= !unquote(!cutp)
 !if (!head(!order)='D') !then !let !op= '>' !let !sop= '<' !else !let !op= '<' !let !sop= '>' !ifend
 !if (!incp<>'SEN') !then !let !op= !conc(!op,'=') !ifend
 !if (!missing<>'INCLUDE') !then !let !rmiss= !quote(' (miss=sysmis)')
 !else !if (!cap=!null) !then
- miss val !vars ().
 !ifend !ifend
-string nvars##$ (a8).
-do if $casenum=1.
- count nvars###= !vars (lo thru hi miss).
- comp nvars##$= ltrim(string(nvars###,f8)).
- write outfile= 'temp_KO_hbinef_1.sps'
    !if (!cap<>!null) !then !let !newvars= !quote(!conc(!cp,1,' to ',!cp))
      /'numer ' !newvars nvars##$ ' (f8)'
      /'var lev ' !newvars nvars##$ ' (ord)'
      /'recode ' !quote(!vars) !rmiss ' (else=copy) into ' !newvars nvars##$
    !ifend
      /'recode ' !quote(!vars) !rmiss ' (else=copy) into #1 to #' nvars##$
      /'comp #n= nvalid(#1 to #' nvars##$ ')'
      /'vector v= #1 to #' nvars##$ ' /#s #e (' nvars##$ ')'.
- write outfile= 'temp_KO_hbinef_2.sps'
      /'recode #s1 to #s' nvars##$ ' (else=0)'
      /'comp #s(1)= 1'
      /'comp #e(1)= ' nvars##$
      /'comp #w= 2'
      /'loop #r= 1 to ' nvars##$ ' if #s(#r)>0'
      /'comp #s= #s(#r)'
      /'loop #w= #w to ' nvars##$ ' if #s<#e(#r)'.
- write outfile= 'temp_KO_hbinef_3.sps'
      /'do rep var= ' !if (!cap=!null) !then !quote(!vars) !else !newvars nvars##$ !ifend.
- write outfile= 'temp_KO_hbinef_4.sps'
      /'recode ' !if (!cap=!null) !then !quote(!vars) !else !newvars nvars##$ !ifend
    !if (!freq<>!null) !then
      /' ' !quote(!conc(!fr,1,' to ',!fr,!k))
    !ifend
    !if (!cutp<>!null) !then
      /' ' !quote(!conc(!ctp,1,' to ',!ctp,!k))
    !ifend
      /' (else=sysmis)'.
-end if.
-exec.
-insert file= 'temp_KO_hbinef_1.sps' syntax= batch.
 !if (!tail(!order)=!null) !then
- insert file= 'temp_KO_hbinef_2.sps' syntax= batch.
-   comp #p= trunc((#s+#e(#r))/2).
-   comp #temp= v(#p).
-   comp v(#p)= v(#s).
-   comp v(#s)= #temp.
-   comp #p= #e(#r).
-   loop #i= #e(#r) to #s+1 by -1.
-    do if v(#i) !sop v(#s) or miss(v(#i)).
-     comp #temp= v(#i).
-     comp v(#i)= v(#p).
-     comp v(#p)= #temp.
-     comp #p= #p-1.
-    end if.
-   end loop.
-   comp #temp= v(#s).
-   comp v(#s)= v(#p).
-   comp v(#p)= #temp.
-   comp #s(#w)= #s.
-   comp #e(#w)= #p-1.
-   comp #s= #p+1.
-  end loop.
- end loop.
 !ifend
 !if (!cutp=!null) !then !let !ctp= '#cp' !ifend
-vector !ctp !fr (!k,f8).
-do if #n>0.
- loop #p= 1 to !k-1.
   !if (!trunc='NO') !then
-   comp #t= #n*#p/!k.
   !else
-   comp #t= #n*trunc(#p/!k,!mult).
   !ifend
-  do if #t=0.
-   comp !ctp(#p)= v(1).
-  else.
-   comp #i= trunc(#t).
-   do if #t=#i.
-    comp !ctp(#p)= (v(#i)+v(#i+1))/2.
-   else.
-    comp !ctp(#p)= v(#i+1).
-   end if.
-  end if.
- end loop.
-end if.
-comp #w= 1.
-loop #i= 2 to !k-1.
- do if !ctp(#i)<>!ctp(#w).
-  comp #w= #w+1.
-  comp !ctp(#w)= !ctp(#i).
- end if.
-end loop.
-loop #i= #w+1 to !k-1.
- comp !ctp(#i)= $sysmis.
-end loop.
-insert file= 'temp_KO_hbinef_3.sps' syntax= batch.
- do if not miss(var).
-  loop #i= 1 to #w.
-  end loop if var !op !ctp(#i).
-  comp var= #i.
   !if (!freq<>!null) !then
-   comp !fr(#i)= sum(!fr(#i),1).
   !ifend
  !if (!missing<>'INCLUDE' !and !cap=!null) !then
-  else.
-   comp var= $sysmis.
  !ifend
- end if.
-end rep.
 !if (!flag='YES') !then
- comp nvalid#$= #n.
- var lab nvalid#$ 'No. of valid values in Input variables'.
- var lev nvalid#$ (sca).
- format nvalid#$ (f8).
- echo ''.
- echo '>NOTE. Variable nvalid#$ has been created or updated.'.
 !ifend
-set errors none.
-do if #n< !if (!nvalid=!null) !then 1 !else !nvalid !ifend .
- insert file= 'temp_KO_hbinef_4.sps' syntax= batch.
-end if.
-set errors list.
-exec.
-del vari nvars### nvars##$.
 !if (!cap=!null) !then
- miss val !vars ().
- format !vars (f8).
- var lev !vars (ord).
 !ifend
 !if (!cutp<>!null) !then
- format !conc(!ctp,1) to !conc(!ctp,!k) (f8.4).
- var lev !conc(!ctp,1) to !conc(!ctp,!k) (sca).
- del var !conc(!ctp,!k).
 !ifend
 !if (!freq<>!null) !then
- var lev !conc(!fr,1) to !conc(!fr,!k) (sca).
 !ifend
-erase file 'temp_KO_hbinef_1.sps'.
-erase file 'temp_KO_hbinef_2.sps'.
-erase file 'temp_KO_hbinef_3.sps'.
-erase file 'temp_KO_hbinef_4.sps'.
!else
-echo '>!KO_HBINEF is not executed.'.
!ifend
!enddefine.

*/*!KO_HBINEI*/vers1***************************************************************************************.
define !KO_hbinei(vars= !charend('/') /cap= !charend('/') /k= !charend('/') /order= !charend('/') /sw= !charend('/') /incp= !charend('/') /outcodes= !charend('/')
                 /midinter= !charend('/') /missing= !charend('/') /nvalid= !charend('/') /cutp= !charend('/') /freq= !charend('/') /flag= !charend('/'))
exec.
!let !ok= 1
!if (!k=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. K is not specified.'.
!else !if (!incp=!null) !then !let !ok= 0
-echo ''.
-echo '>ERROR. INCP is not specified.'.
!else !if (!cap=!null !and !flag='YES') !then !let !ok= 0
-echo ''.
-echo '>ERROR. FLAG=YES is allowed only with CAP specified.'.
!else !if (!freq<>!null !and (!unquote(!freq)=!null !or !head(!unquote(!freq))=!null)
       !or !cutp<>!null !and (!unquote(!cutp)=!null !or !head(!unquote(!cutp))=!null)) !then !let !ok= 0
-echo ''.
-echo '>ERROR. Incorrectly specified CUTP or FREQ.'.
!else !if (!sw<>'AUTO' !and !sw<>!null) !then
 !if (!head(!sw)<>'-' !and !tail(!sw)=!null !or !head(!sw)='-' !and !tail(!tail(!sw))=!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. Incorrectly specified SW.'.
 !ifend
 !if (!head(!outcodes)<>'-' !and !tail(!outcodes)=!null !or !head(!outcodes)='-' !and !tail(!tail(!outcodes))=!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. Incorrectly specified OUTCODES.'.
 !ifend
!ifend !ifend !ifend !ifend !ifend
!if (!ok) !then !let !cp= !unquote(!cap) !let !fr= !unquote(!freq) !let !ctp= !unquote(!cutp)
 !let !vars1= !null !let !vars2= !null !let !wasto= 0
 !do !w !in (!vars)
  !if (!upcase(!w)='TO') !then !let !wasto= 1
  !else
   !if (!wasto) !then !let !w2= !conc(' to ',!w)
    !let !vars1= !conc(!vars1,'/',!quote(!w2)) !let !vars2= !conc(!vars2,!w2)
   !else
    !let !vars1= !conc(!vars1,'/',!quote(!conc(' ',!w))) !let !vars2= !conc(!vars2,',',!w)
   !ifend
   !let !wasto= 0
  !ifend
 !doend
 !let !vars2= !tail(!vars2)
 !if (!order='D') !then !let !op= '>' !let !plus= '-' !else !let !op= '<' !let !plus= '+' !ifend
 !if (!incp<>'SEN') !then !let !op= !conc(!op,'=') !ifend
 !if (!missing<>'INCLUDE') !then !let !rmiss= !quote(' (miss=sysmis)')
 !else !if (!cap=!null) !then
- miss val !vars ().
 !ifend !ifend
-string nvars##$ (a8).
-do if $casenum=1.
- count nvars###= !vars (lo thru hi miss).
- comp nvars##$= ltrim(string(nvars###,f8)).
  !if (!cap<>!null) !then !let !newvars= !quote(!conc(!cp,1,' to ',!cp))
-  write outfile= 'temp_KO_hbinei_1.sps'
      /'numer ' !newvars nvars##$ !if (!midinter='YES') !then ' (f8.2)' !else ' (f8)' !ifend
      /'var lev ' !newvars nvars##$ !if (!midinter='YES') !then ' (sca)' !else ' (ord)' !ifend
      /'recode ' !vars1
      /' ' !rmiss ' (else=copy) into ' !newvars nvars##$
      /'comp #n= nvalid(' !newvars nvars##$ ')'
     !if (!sw='AUTO' !or !sw=!null) !then
      /'comp #min= min(' !newvars nvars##$ ')'
      /'comp #max= max(' !newvars nvars##$ ')'
     !ifend .
  !ifend
- write outfile= 'temp_KO_hbinei_2.sps'
      /'do rep var= ' !if (!cap=!null) !then !vars1 !else /' ' !newvars nvars##$ !ifend.
- write outfile= 'temp_KO_hbinei_3.sps'
      /'recode ' !if (!cap=!null) !then !vars1 !else /' ' !newvars nvars##$ !ifend
    !if (!freq<>!null) !then
      /' ' !quote(!conc(!fr,1,' to ',!fr,!k))
    !ifend
    !if (!cutp<>!null) !then
      /' ' !quote(!conc(!ctp,1,' to ',!ctp,!k))
    !ifend
      /' (else=sysmis)'.
-end if.
-exec.
 !if (!cap<>!null) !then
- insert file= 'temp_KO_hbinei_1.sps' syntax= batch.
 !ifend
 !if (!cap=!null) !then
- comp #n= nvalid(!vars2).
  !if (!sw='AUTO' !or !sw=!null) !then
-  comp #min= min(!vars2).
-  comp #max= max(!vars2).
  !ifend
 !ifend
 !if (!sw='AUTO' !or !sw=!null) !then
- comp #wid= (#max-#min)/!k.
- comp #st= !if (!order='D') !then #max !else  #min !ifend.
 !else
  !if (!head(!sw)<>'-') !then !let !st= !head(!sw) !let !wid= !tail(!sw)
  !else !let !st= !conc('-',!head(!tail(!sw))) !let !wid= !tail(!tail(!sw))
  !ifend
  !if (!head(!wid)='-') !then !let !wid= !head(!tail(!wid))
-  echo ''.
-  echo '>WARNING. 2nd parameter in SW has neg. sign. The sign will be ignored.'.
  !else !let !wid= !head(!wid)
  !ifend
  !if (!head(!outcodes)<>'-') !then !let !out1= !head(!outcodes) !let !out2= !tail(!outcodes)
  !else !let !out1= !conc('-',!head(!tail(!outcodes))) !let !out2= !tail(!tail(!outcodes))
  !ifend
  !if (!index('-.1234567890',!substr(!st,1,1))>0 !and !index('.1234567890',!substr(!wid,1,1))>0) !then
   !let !doif1= 'do if $casenum=1' !let !endif1= 'end if'
   !if (!cutp<>!null) !then  !let !leavectp= !conc('leave ',!ctp,1,' to ',!ctp,!k) !ifend
  !ifend
- comp #wid= !wid.
- comp #st= !st.
 !ifend
 !if (!cutp=!null) !then !let !ctp= '#cp'
 !else
- comp !conc(!ctp,0)= #st.
- var lab !conc(!ctp,0) 'Start point'.
 !ifend
-vector !ctp !fr (!k,f8).
-!doif1. 
- loop #i= 1 to !k.
-  comp !ctp(#i)= #st !plus #i*#wid.
- end loop.
-!endif1.
-!leavectp.
-insert file= 'temp_KO_hbinei_2.sps' syntax= batch.
- do if not miss(var).
  !if (!sw<>'AUTO' !and !sw<>!null) !then !let !endif= 'end if' !let !ine0= 'if #i>0'
-  do if var !op #st.
-   comp var= !out1.
    !if (!freq<>!null) !then
-    comp #i= 0.
    !ifend
-  else.
  !ifend
-   loop #i= 1 to !k.
-   end loop if var !op !ctp(#i).
   !if (!midinter='YES') !then
-   do if #i=1.
-    comp var= (#st+!ctp(#i))/2.
-   else if #i>!k.
-    comp var= !if (!sw='AUTO' !or !sw=!null) !then (!ctp(!k)+!ctp(!k-1))/2 !else !out2 !ifend.
-   else.
-    comp var= (!ctp(#i)+!ctp(#i-1))/2.
-   end if.
   !else
-   do if #i>!k.
-    comp var= !if (!sw='AUTO' !or !sw=!null) !then !k !else !out2 !ifend.
-   else.
-    comp var= #i.
-   end if.
   !ifend
-  !endif.
   !if (!freq<>!null) !then
-   do if #i>!k.
     !if (!sw='AUTO' !or !sw=!null) !then
-     comp !fr(!k)= sum(!fr(!k),1).
     !ifend
-   else !ine0.
-    comp !fr(#i)= sum(!fr(#i),1).
-   end if.
   !ifend
  !if (!missing<>'INCLUDE' !and !cap=!null) !then
-  else.
-   comp var= $sysmis.
  !ifend
- end if.
-end rep.
 !if (!flag='YES') !then
- comp nvalid#$= #n.
- var lab nvalid#$ 'No. of valid values in Input variables'.
- var lev nvalid#$ (sca).
- format nvalid#$ (f8).
- echo ''.
- echo '>NOTE. Variable nvalid#$ has been created or updated.'.
 !ifend
-set errors none.
-do if #n< !if (!nvalid=!null) !then 1 !else !nvalid !ifend .
- insert file= 'temp_KO_hbinei_3.sps' syntax= batch.
-end if.
-set errors list.
-exec.
-del vari nvars### nvars##$.
 !if (!cap=!null) !then
- miss val !vars ().
- format !vars !if (!midinter='YES') !then (f8.2) !else (f8)!ifend.
- var lev !vars !if (!midinter='YES') !then (sca) !else (ord) !ifend.
 !ifend
 !if (!cutp<>!null) !then
- format !conc(!ctp,0) to !conc(!ctp,!k) (f8.4).
- var lev !conc(!ctp,0) to !conc(!ctp,!k) (sca).
 !ifend
 !if (!freq<>!null) !then
- var lev !conc(!fr,1) to !conc(!fr,!k) (sca).
 !ifend
 !if (!cap<>!null) !then
- erase file 'temp_KO_hbinei_1.sps'.
 !ifend
-erase file 'temp_KO_hbinei_2.sps'.
-erase file 'temp_KO_hbinei_3.sps'.
!else
-echo '>!KO_HBINEI is not executed.'.
!ifend
!enddefine.

*/*!KO_HFREQ*/vers1***************************************************************************************.
define !KO_hfreq(vars= !charend('/') /values= !charend('/') /discret= !charend('/') /cap= !charend('/') /ending= !charend('/')
                /negsign= !charend('/') !default('_'))
exec.
!let !ok= 1 !let !cp= !unquote(!cap)
!if (!cp=!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. CAP is not specified.'.
!ifend !let !cp= !quote(!cp)
!if (!discret=!null) !then !let !discr= 'RND' !let !dec= 0 !let !mult= 1
!else !let !discr= !head(!discret) !let !dec= !head(!tail(!discret))
 !if (!dec=!null) !then !let !ok= 0
- echo ''.
- echo '>ERROR. In DISCRET, a keyword and an integer must be specified.'.
 !else !if (!dec<>0 !and !dec<>1 !and !dec<>2 !and !dec<>3) !then !let !ok= 0
- echo ''.
- echo '>ERROR. Parameter d in DISCRET can be only 0, 1, 2, or 3.'.
 !else
  !if (!dec=0) !then !let !mult= 1 !ifend
  !if (!dec=1) !then !let !mult= 0.1 !ifend
  !if (!dec=2) !then !let !mult= 0.01 !ifend
  !if (!dec=3) !then !let !mult= 0.001 !ifend
 !ifend !ifend
!ifend
!if (!ok) !then
-dataset copy hfreq#$#$._.
-dataset activ hfreq#$#$._.
-filter off.
-use all.
-split file off.
-weight off.
-match files /file= * /keep= !vars.
 !if (!values<>!null )!then
- recode !vars (!values=copy) (else=sysmis).
 !ifend
-do rep v= !vars.
- comp v= !discr(v,!mult).
-end rep.
-dataset copy restr#$#$._ window= hidden.
-dataset activ restr#$#$._.
-set results none errors none.
-varstocas /make res$$$$$._ from all /keep= /null= keep.
-set results list errors list.
-aggreg /out= * /break= res$$$$$._ /cnt$$$$$._= nu.
-miss val res$$$$$._ ().
-dataset close restr#$#$._.
-string res$$$$$._$ end$$$$$._$ lab$$$$$._$ (a19).
-do if res$$$$$._=0.
- comp res$$$$$._$= '0'.
-else.
- comp res$$$$$._$= ltrim(string(res$$$$$._,!conc('f16.',!dec))).
- comp #pos= char.index(res$$$$$._$,'.').
- do if #pos>0.
-  comp res$$$$$._$= rtrim(res$$$$$._$,'0').
-  if #pos= char.len(res$$$$$._$) res$$$$$._$= rtrim(res$$$$$._$,'.').
-  do if #pos=1.
-   comp res$$$$$._$= conc('0',res$$$$$._$).
-  else if #pos=2 and char.substr(res$$$$$._$,1,1)='-'.
-   comp res$$$$$._$= conc('-0.',char.substr(res$$$$$._$,3)).
-  end if.
- end if.
-end if.
 !if (!ending='INDEX') !then
- if not sysmis(res$$$$$._) #ind= #ind+1.
- comp end$$$$$._$= ltrim(string(#ind,f8)).
 !else
- comp end$$$$$._$= res$$$$$._$.
- if char.substr(end$$$$$._$,1,1)='-' substr(end$$$$$._$,1,1)= !quote(!unquote(!negsign)).
 !ifend
-comp lab$$$$$._$= conc("'",res$$$$$._$,"'").
-do if sysmis(res$$$$$._).
- write out= 'temp_KO_hfreq.sps'
       /'count ntotal#$= '
      !do !w !in (!vars)
       /' ' !quote(!w)
      !doend
       /' (lo thru hi)'
       /'format ntotal#$ (f8)'
       /'var lev ntotal#$ (sca)'.
-else.
- write out= 'temp_KO_hfreq.sps'
       /'count ' !cp end$$$$$._$ '= '
      !do !w !in (!vars)
       /' ' !quote(!w)
      !doend
       /' (' res$$$$$._$ ')'
       /'format ' !cp end$$$$$._$ '(f8)'
       /'var lab ' !cp end$$$$$._$ lab$$$$$._$
       /'var lev ' !cp end$$$$$._$ '(sca)'.
-end if.
-exec.
-dataset activ hfreq#$#$._.
-insert file= 'temp_KO_hfreq.sps' syntax= batch.
-match files /file= * /drop= !vars.
-exec.
-dataset close *.
-erase file 'temp_KO_hfreq.sps'.
!else
-echo '>!KO_HFREQ is not executed.'.
!ifend
!enddefine.

*/*!KO_HCOUNT*/vers2***************************************************************************************.
define !KO_hcount(vars= !charend('/') /values= !charend('/') /missing= !charend('/') /rtimes= !charend('/') /cap= !charend('/'))
exec.
!if (!missing<>'INCLUDE') !then !let !rcmiss= ' (miss=sysmis) ' !ifend
!if (!values=!null) !then !let !vals= 'lo thru hi' !else !let !vals= !values !ifend
!if (!rtimes=!null) !then !let !rt= '>1' !else !let !rt= !rtimes !let !rtt= !conc(' (by ',!rt,' encounters)') !ifend
!let !vars1= !null !let !wasto= 0
!do !w !in (!vars)
 !if (!upcase(!w)='TO') !then !let !wasto= 1
 !else
  !if (!wasto) !then !let !vars1= !conc(!vars1,'/',!quote(!conc(' to ',!w)))
  !else !let !vars1= !conc(!vars1,'/',!quote(!conc(' ',!w)))
  !ifend
  !let !wasto= 0
 !ifend
!doend
count nvars###= !vars (lo thru hi miss).
string nvars##$ (a8).
comp nvars##$= ltrim(string(nvars###,f8)).
!if (!cap=!null) !then !let !uniq= 'uniq#' !let !uniq_s= 'uniq_s#' !let !uniq_r= 'uniq_r#' !let !r_max= 'r_max#' !let !r_min= 'r_min#'
!else !let !cp= !unquote(!cap)
 !let !uniq= !conc(!cp,'uniq#') !let !uniq_s= !conc(!cp,'uniq_s#') !let !uniq_r= !conc(!cp,'uniq_r#') !let !r_max= !conc(!cp,'r_max#') !let !r_min= !conc(!cp,'r_min#')
-numer !uniq !uniq_s !uniq_r !r_max !r_min.
!ifend
do if $casenum=1.
-write outfile= 'temp_KO_hcount_1.sps'
      /'recode ' !vars1
      /!quote(!rcmiss) '(' !quote(!vals) '=copy) (else=sysmis) into #1 to #' nvars##$ '.'
      /'vector #= #1 to #' nvars##$ '.'.
-write outfile= 'temp_KO_hcount_2.sps'
      /'comp ' !quote(!uniq) '= nvalid(#1 to #' nvars##$ ').'.
end if.
exec.
insert file= 'temp_KO_hcount_1.sps'.
comp !uniq= 0.
comp !uniq_s= 0.
comp !uniq_r= 0.
comp #uniq_r= 0.
comp !r_max= 0.
comp !r_min= nvars###+1.
miss val !uniq !uniq_s !uniq_r !r_max !r_min ().
loop #i= 1 to nvars###-1.
-do if not miss(#(#i)). 
- comp #count= 0.
- loop #j= #i+1 to nvars###.
-  do if #(#j)=#(#i).
-   comp #count= #count+1.
-   comp #(#j)= $sysmis.
-  end if.
- end loop.
- do if #count>0.
-  comp !uniq_r= !uniq_r+(#count+1 !rt).
-  comp #uniq_r= #uniq_r+(#count+1>1).
-  comp !r_max= max(!r_max,#count+1).
-  comp !r_min= min(!r_min,#count+1).
- end if.
-end if.
end loop.
insert file= 'temp_KO_hcount_2.sps'.
comp !uniq_s= !uniq-#uniq_r.
if !r_min=nvars###+1 !r_min= 0.
exec.
del vari nvars### nvars##$.
var lab !uniq !quote(!conc('Number of encountered distinct values ',!values))
        !uniq_s !quote(!conc('Number of distinct values encountered 1 time ',!values))
        !uniq_r !quote(!conc('Number of repeating',!rtt,' distinct values ',!values))
        !r_max !quote(!conc('Maximal number of repetitions among values ',!values))
        !r_min !quote(!conc('Minimal number of repetitions among values ',!values)).
format !uniq !uniq_s !uniq_r !r_max !r_min (f8).
var lev !uniq !uniq_s !uniq_r !r_max !r_min (sca).
erase file 'temp_KO_hcount_1.sps'.
erase file 'temp_KO_hcount_2.sps'.
!enddefine.

*/*!KO_HGAPS*/vers2***************************************************************************************.
define !KO_hgaps(vars= !charend('/') /sorted= !charend('/') /missing= !charend('/') /cap= !charend('/'))
exec.
!if (!missing<>'INCLUDE') !then !let !rcmiss= ' (miss=sysmis)' !ifend
!let !vars1= !null !let !wasto= 0
!do !w !in (!vars)
 !if (!upcase(!w)='TO') !then !let !wasto= 1
 !else
  !if (!wasto) !then !let !vars1= !conc(!vars1,'/',!quote(!conc(' to ',!w)))
  !else !let !vars1= !conc(!vars1,'/',!quote(!conc(' ',!w)))
  !ifend
  !let !wasto= 0
 !ifend
!doend
count nvars###= !vars (lo thru hi miss).
string nvars##$ (a8).
comp nvars##$= ltrim(string(nvars###,f8)).
!if (!cap=!null) !then !let !ngap= 'ngap#' !let !mingap= 'mingap#' !let !maxgap= 'maxgap#' !let !meangap= 'meangap#' !let !sdgap= 'sdgap#'
!else !let !cp= !unquote(!cap)
 !let !ngap= !conc(!cp,'ngap#') !let !mingap= !conc(!cp,'mingap#') !let !maxgap= !conc(!cp,'maxgap#') !let !meangap= !conc(!cp,'meangap#') !let !sdgap= !conc(!cp,'sdgap#')
-numer !ngap !mingap !maxgap !meangap !sdgap.
!ifend
do if $casenum=1.
-write outfile= 'temp_KO_hgaps.sps'
       /'recode ' !vars1
       /!quote(!rcmiss) ' (else=copy) into #1 to #' nvars##$ '.'
       /'vector #= #1 to #' nvars##$ '.'
       /'comp #min= min(#1 to #' nvars##$ ').'
       /'comp #max= max(#1 to #' nvars##$ ').'.
end if.
exec.
insert file= 'temp_KO_hgaps.sps'.
comp !ngap= 0.
comp !mingap= #max-#min.
comp !maxgap= 0.
comp !meangap= 0.
comp !sdgap= 0.
comp #sum= 0.
comp #ss= 0.
miss val !ngap !mingap !maxgap !meangap !sdgap ().
!if (!sorted='YES') !then
-do if #max>#min.
- loop #i= 1 to nvars###-1.
- end loop if not miss(#(#i)).
- comp #val= #(#i).
- loop #i= #i+1 to nvars###.
-  comp #gap= abs(#(#i)-#val).
-  do if #gap>0.
-   comp !ngap= !ngap+1.
-   comp !mingap= min(!mingap,#gap).
-   comp !maxgap= max(!maxgap,#gap).
-   comp #sum= #sum+#gap.
-   comp #ss= #ss+#gap*#gap.
-   comp #val= #(#i).
-  end if.
- end loop.
- comp !meangap= #sum/(!ngap+(!ngap=0)).
- comp !sdgap= sqrt((#ss-#sum*!meangap)/((!ngap-1)+(!ngap=1))).
-end if.
-if miss(#max) !ngap= -1.
!else
-loop #i= 1 to nvars###.
- comp #val= #(#i).
- do if not miss(#val).
-  comp #uneib= #max.
-  comp #lneib= #min.
-  loop #j= 1 to nvars###.
-   do if #(#j)>#val.
-    comp #uneib= min(#uneib,#(#j)).
-   else if #(#j)<#val.
-    comp #lneib= max(#lneib,#(#j)).
-   else if #j>#i.
-    comp #(#j)= $sysmis.
-   end if.
-  end loop.
-  comp !maxgap= max(!maxgap,#uneib-#val,#val-#lneib).
-  comp !mingap= min(!mingap,#uneib-#val+!mingap*(#val=#max),#val-#lneib+!mingap*(#val=#min)).
-  comp #sum= #sum+#uneib-#lneib.
-  comp #ss= #ss+(#uneib-#val)**2+(#val-#lneib)**2.
-  comp !ngap= !ngap+1.
- end if.
-end loop.
-comp !ngap= !ngap-1.
-comp !meangap= #sum/2/(!ngap+(!ngap=0)).
-comp !sdgap= sqrt((#ss-#sum*!meangap)/2/((!ngap-1)+(!ngap=1))).
!ifend
if !maxgap=0 !mingap= 0.
exec.
del vari nvars### nvars##$.
var lab !ngap 'No. of gaps' !mingap 'Minimal gap' !maxgap 'Maximal gap' !meangap 'Averaged gap' !sdgap 'Std. dev. of gaps'.
format !ngap (f8).
var lev !ngap !mingap !maxgap !meangap !sdgap (sca).
erase file 'temp_KO_hgaps.sps'.
!enddefine.
